﻿//
// MainPage.xaml.cpp
// MainPage クラスの実装。
//

#include "pch.h"
#include <ppltasks.h>
#include "MainPage.xaml.h"

using namespace App1;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::Storage;

using namespace concurrency;
using namespace Windows::Media::Capture;
using namespace Windows::Foundation;
using namespace Windows::UI::Xaml::Media::Imaging;

// 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

MainPage::MainPage()
{
	InitializeComponent();

}

/// <summary>
/// このページがフレームに表示されるときに呼び出されます。
/// </summary>
/// <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
/// プロパティは、通常、ページを構成するために使用します。</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// 未使用のパラメーター
}


void App1::MainPage::my_btn_01_click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
    task<StorageFile^>(KnownFolders::DocumentsLibrary->CreateFileAsync(my_txt->Text, CreationCollisionOption::ReplaceExisting))
	.then([this](StorageFile^ file)
    {
		my_btn_01->Content = "作られたよ";
		my_file = file;
    });
	
}


void App1::MainPage::my_btn_02_click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	StorageFile^ file = my_file;

    if (file != nullptr)
    {
		String^ wtn_str = my_txt->Text;
		if ((wtn_str != nullptr) && (!wtn_str->IsEmpty()))
		{
			create_task(FileIO::WriteTextAsync(file, wtn_str))
			.then([this, file, wtn_str](task<void> task)
            {
				try{
					task.get();
					my_txt->Text = "書き込んだよ";
				}catch(COMException^ ex){
					my_txt->Text = "書き込み失敗したよ０";
				}
			});
		}else{
			my_txt->Text = "書き込み失敗したよ１";
		}
    }
}


void App1::MainPage::my_btn_03_click(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	StorageFile^ file = my_file;

    if (file != nullptr)
    {
        create_task(FileIO::ReadTextAsync(file)).then([this, file](task<String^> task)
        {
            try
            {
                String^ fileContent = task.get();
                my_txt->Text = "ファイル読んだよ '" + file->Name + "':\n\n" + fileContent;
            }
            catch(COMException^ ex)
            {
                my_txt->Text = "読み込み失敗したよ";
            }
        }).then([this](task<void> task)
		{
			try
			{
				CameraCaptureUI^ dialog = ref new CameraCaptureUI();

				dialog->PhotoSettings->CroppedAspectRatio = Size(16, 9);

				concurrency::task<StorageFile^> (dialog->CaptureFileAsync(CameraCaptureUIMode::Photo)).then([this] (StorageFile^ file)
				{
					if (nullptr != file)
					{
						concurrency::task<Streams::IRandomAccessStream^> (file->OpenAsync(FileAccessMode::Read)).then([this] (Streams::IRandomAccessStream^ stream)
						{
							BitmapImage^ bitmapImage = ref new BitmapImage();
							bitmapImage->SetSource(stream);		
							CapturedPhoto->Source = bitmapImage;	
							ResetButton->Visibility = Windows::UI::Xaml::Visibility::Visible;
						});
					}
					else
					{
		                my_txt->Text = "カメラ撮影失敗したよ０";
					}
				});

			}
			catch (Platform::Exception^ ex)
			{
		        my_txt->Text = "カメラ撮影失敗したよ０";
			}
		});
    }
}


void App1::MainPage::ResetButton_Click_1(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	ResetButton->Visibility = Windows::UI::Xaml::Visibility::Collapsed;
    CapturedPhoto->Source = ref new BitmapImage(ref new Windows::Foundation::Uri(BaseUri->AbsoluteUri, "Assets/storeLogo.png"));

}
